;wac a pac

AppTitle "Wac A Pac Beta For Stick Man wednesday workshop",":'( Are you sure you want To leave?"  


Graphics 800,600,16,screen : HidePointer 

SeedRnd MilliSecs()
Print "Loading..."
SetBuffer BackBuffer()  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;IMAGES;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;walking guy ;;;
Global guy = LoadAnimImage("walk_guy.png",100,160,0,9) : MaskImage guy,255,0,255 
;;; key ;;;;
Global key_image = LoadAnimImage("key.png",102,50,0,2) : MaskImage key_image,255,0,255
;;; enemy ;;;
Global enemy_image = LoadAnimImage("enemy_anim copy.png",73,85,0,4) : MaskImage enemy_image,255,0,255
;;; background ;;;
Global bg = LoadImage("nuksky2.jpg")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;SOUNDS/MUSIC;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Global BOING = LoadSound("Sound\BOING5.WAV") :SoundVolume boing,0.3
Global win = LoadSound("Sound\congrats.wav")
Global lose = LoadSound("Sound\theend.wav")
Global bg_music = PlayMusic("sound\Interim Nation - Future Experience.ogg") : PauseChannel bg_music
Global scream = LoadSound("sound\playerdeath.wav")
 
;;;;;;;key constants
Const LEFTKEY = 203
Const RIGHTKEY = 205
Const ESCAPE = 1
Const UPKEY = 200

;;;Misc. Globals
Global ground = 440 ;;y location of ground

;;;some variables for really bad frame speed limiting
Global loop_frame = 0
Global lose_win
Global loop_frame2 = 0

Global bg_x# ;;background x

Global sndpan# ;;sound pan for bounce sound

Global enemycounter% ;;how many enemies have been destroyed
Global debug 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;TYPES;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Type player
	Field x#,y
	Field yv#
	Field feet_y
	Field frame
	Field die
	Field score
End Type

Type enemy
	Field x,y
	Field xv,yv
	Field frame
End Type

Type key
	Field x,y
	Field xv
	Field frame
End Type

Type music
	Field vol#
	Field vv# ;;volume "velocity"
End Type 

Global p.player
Global e.enemy
Global k.key
Global m.music
CreateEnemy()
CreatePlayer()
StartMusic()
CreateKey()
Cls

For ft = 0 To 255 Step 5
	Color ft,ft,ft 
	Text 400,300,"WAC-A-PAC",1,1
	Text 400,320,"BETA v0.01",1,1
	Flip 
Next 
Delay 2000
;For x = 0 To 470 Step 10
;	Cls 
;	Text 400+x,300,"WAC-A-PAC",1,1
;	Text 400-x,320,"BETA v0.01",1,1
;	Flip 
;Next 

title$ = "WAC-A-PAC"
title2$ = "BETA v0.01"
For s = 0 To 70
	Cls
	For l = 1 To StringWidth(title$)
		lstr$ = Mid(title$,l,1)
		lstr2$ = Mid(title2$,l,1)
		Text (GraphicsWidth()/2)+(StringWidth(lstr$)*l)+(s * (l-(Len(title$))/2))-(StringWidth(title$)/2),(GraphicsHeight()/2)+(100*(Tan(l+s))),lstr$,1,1
		Text (GraphicsWidth()/2)+(StringWidth(lstr$)*l)+(s * (l-(Len(title2$))/2))-(StringWidth(title2$)/2)+15,(GraphicsHeight()/2)+(140*(Tan(l+s))),lstr2$,1,1

	Next
	Flip
Next 

FlushKeys()
;title screen
Repeat
	Cls
	If e\frame = 0 Then enemyframe = 2
	If e\frame = 1 Then enemyframe = 3  
	Text 0,0,"Get this key when it's yellow to win"
	DrawImage key_image,0,0,0
	Text 0,ImageHeight(key_image),"But you can't get it when it's red"
	DrawImage key_image,0,ImageHeight(key_image),1  
	Text 0,100,"Avoid this evil pacman guy because he makes you lose."
	Text 0,115,"Jump on it to kill it."
	DrawImage enemy_image,0,130,enemyframe 
	Text 0,210,"Press any key to start"
	e\frame = Not e\frame
	Delay 200
	Flip   
Until GetKey() <> 0 Or played = True 

For ft = 0 To 255 Step 2
	Color ft,ft,ft
	Rect 0,0,GraphicsWidth(),GraphicsHeight(),1
	Color 0,0,0
	Text GraphicsWidth()/2,GraphicsHeight()/2,"Get Ready",1,1
	Flip 
Next 

SetBuffer BackBuffer() 

Global platform = LoadImage("platform.png") : MaskImage platform,255,0,255


ClsColor 255,255,255 

;;;;;;;;;;;;;;;;;;;;;==========================================================;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;=========================================================================================================;


;If screen = 1 Then Delay 2000 ;if the game is in full screen wait for 2 seconds until it shows up


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;MAIN LOOP;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

While Not KeyHit(ESCAPE) Or lose_win 
	Cls	

	UpdateGame()
	
	Gravity()
	
	If Not p\die Then TestKeys()
	
	DrawImages()
	
	If KeyHit(3) Then debug = Not debug
	PrintGameData()
		
	FlushKeys()
	
	If loop_frame > 4 Then loop_frame = 0
	If loop_frame2 >= 10 Then loop_frame2 = 0
	
	VWait : Flip 0
Wend  

SetBuffer FrontBuffer() : Cls 

Delay 100

If lose_win Then 
	GameOver()
EndIf 

End 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;FUNCTIONS;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Function PlayerFloor() ;;Returns the y coordinate of the platform that the player is on
	
	If p\x > 310-ImageWidth(guy) And  p\x < 400 And p\feet_y <= 450
		level =  400
	Else
		level = 600
	EndIf
	
	Return level  

End Function 

;========================================================================================================

Function Gravity() ;; applies gravity
	
	If p\feet_y <= PlayerFloor()-130  Then 
		p\yv = p\yv + 0.5
	ElseIf p\feet_y >= PlayerFloor() And p\die = 0 Then
		p\y = PlayerFloor()-160
		p\yv = 0
	ElseIf KeyDown(upkey)=0 And p\feet_y<playerfloor() Then 
		p\yv = p\yv + 0.5
	EndIf

End Function 

;=========================================================================================================

Function TestKeys() ;; checks if any keys were hit (DUH!!! :P) 
	If KeyDown(57) Then Flip 10
	
	If KeyHit(leftkey) Then p\frame = 3
	If KeyHit(rightkey) Then p\frame = 4

	If KeyDown(leftkey) And p\x>0
		If loop_frame = 4 Then p\frame = p\frame - 1
		p\x = p\x - 5
		If p\frame<0 Then p\frame = 3
	ElseIf KeyDown(rightkey) And p\x<720
		If loop_frame = 4 Then p\frame = p\frame + 1
		If p\frame>7 Then p\frame = 4
		p\x = p\x + 5
	EndIf
	
	If KeyDown(upkey)
		If p\feet_y>PlayerFloor()-2
			PlaySound boing  
			p\yv = p\yv - 10
		EndIf
	EndIf 
	
End Function 

;=======================================================================================================

Function PrintGameData() ;; again: DUH!!!!
	Text GraphicsWidth()/2,0,"Enemies Destroyed: " + enemycounter,1,0
	Text GraphicsWidth()/2,15,"Score: " + p\score,1,0
	
	If debug
	Color 0,0,0 
	Text 0,0,"Platform is at " + PlayerFloor() + " pixels"
	Text 0,10,"Your x position = " + p\x
	Text 0,20,"Your y position = " + p\y
	Text 0,30,"Your feet's y postion = " + p\feet_y
	Text 0,40,"You vertical(y) velocity = " + p\yv
	Text 0,50,"Enemy's x position = " + e\x
	Text 0,60,"Enemy's y position = " + e\y
	Text 0,70,"Enemy's x velocity = " + e\xv  
	Text 0,80,"Enemy's y velocity = " + e\yv
	Text 0,90,"Enemy image frame = " + e\frame
	Text 0,100,"Sound pan (based on your x postition) = " + sndpan#
	Text 0,110,"Music Volume = " + m\vol
	If Not ChannelPlaying(bg_music) Then mplay_str$ = "not" Else mplay_str$ = ""
	Text 0,120,"The music is " + mplay_str$ + " playing."
	EndIf 

End Function 

;======================================================================================================

Function DrawImages() ;; is a comment really necessary?
	TileImage bg,bg_x#,0
	DrawImage guy,p\x,p\y,p\frame
	DrawImage platform,300,400
	DrawImage key_image,k\x,k\y,k\frame
	DrawImage enemy_image,e\x,e\y,e\frame
	
End Function 

;======================================================================================================

Function GameOver() ;;determines whether to say "you win" or "you lose" 
	Color 0,0,0
	
	If ImagesOverlap(guy,p\x,p\y,key_image,k\x,k\y)
		endstring$ = "100 POINT BONUS!"
		endsound = win
	Else
		endstring$ = "YOU LOST 100 POINTS"
		endsound = lose
	EndIf
	
	Cls
	
	PlaySound endsound 
	Text GraphicsWidth()/2,GraphicsHeight()/2,endstring$,1,1
	
	Delay 2000
	
	Cls
	Text GraphicsWidth()/2,GraphicsHeight()/2,"Final Score: " + p\score,1,1
	
	Delay 2500
	Cls


End Function 

;======================================================================================================
Function UpdateKey()

	If k\x <= 0 
		k\xv = 5
	ElseIf k\x > 700
		k\xv = -5
	EndIf
	
	If loop_frame2 = Rand(100) And ImagesOverlap(guy,p\x,p\y,key_image,k\x,k\y)=0 Then k\frame = Not k\frame 
	
	k\x = k\x + k\xv
	
	CheckKeyCollisions()
End Function

;=======================================================================================================

Function CheckKeyCollisions()

		If ImagesCollide(guy,p\x,p\y,frame,key_image,k\x,k\y,0) And k\frame = 0 Then
			p\score = p\score + 100
			lose_win = True ; this is so the gameover function knows if the player won, lost, or just pressed escape
		EndIf
		
End Function 

;=====================================================================================================

Function UpdateGame()
	UpdateMainLoop()
	
	UpdatePlayer()
	
	UpdateBackground()
	
	UpdateSound()
	
	UpdateMusic()
	
	If Not p\die Then
	 
		UpdateEnemy()
		
		UpdateKey()
	
	EndIf 

End Function 

;========================================================================================================

Function UpdateEnemy()
	If loop_frame2 = 1 Or e\x+e\xv <=0 Or e\x + e\xv >= 660 Then
		If EnemyFacing() = 0 Then
			If e\frame > 1 Then e\frame = 0 
			If e\frame Then
				e\frame = 0
			Else                                            
				e\frame = 1
			EndIf
		ElseIf EnemyFacing() = 1 Then
			If e\frame < 2 Then e\frame = 2
			If e\frame = 2 Then
				e\frame = 3
			ElseIf e\frame = 3                                            
				e\frame = 2
			EndIf	
	
		EndIf
	EndIf 
	
	If e\x <= 0 And e\xv<0 Then e\xv = -e\xv
	If e\x >= GraphicsWidth()-ImageWidth(enemy_image) Then e\xv = -e\xv	
	
	
	If ImagesCollide(guy,p\x,p\y,0,enemy_image,e\x,e\y,e\frame) And e\y = GraphicsHeight()-85 Then
		If (p\y+120) <= e\y And p\yv# >= 0 Then 
			e\xv = 0
			e\yv = 10
		Else
			p\score = p\score - 100
			p\die = 1
			p\frame = 8
			p\yv = -10
			m\vv = -0.01
			PlaySound(scream)
		EndIf
	EndIf
	e\x = e\x + e\xv
	e\y = e\y + e\yv
	
	If e\y > 1000 Then Delete e : enemycounter = enemycounter+1 : p\score = p\score + (10*enemycounter) : CreateEnemy() 

End Function

;===================================================================================================

Function EnemyFacing() ;;left=0 right=1
	If e\xv < 0 Then Return 0
	If e\xv > 0 Then Return 1
End Function

;====================================================================================================

Function CreatePlayer()
	p.player = New player
	p\x = 700
	p\y = -200
	p\yv = -10
	p\feet_y = p\y + 160
	p\frame = 3
	p\score = 0
End Function

;=====================================================================================================

Function CreateEnemy()
	e.enemy = New enemy
	e\x = -1000
	e\y = GraphicsHeight()-85
	e\xv = 10 + (enemycounter/2)
End Function 

;=====================================================================================================

Function UpdateBackground()
	bg_x# = bg_x# + 0.8
End Function 

;=====================================================================================================

Function CreateKey()
	k.key = New key
	k\x = 0
	k\y = 50
	k\xv = 0
	k\frame = 0
End Function 

;======================================================================================================

Function UpdateSound()
	sndpan# = (p\x-400)/400
	If sndpan# > 0 Then sndpan# = (p\x+ImageWidth(guy)-400)/400
	SoundPan boing,sndpan#
End Function

;======================================================================================================

Function UpdatePlayer()
	p\y = p\y + p\yv ;add the y velocity 
	p\feet_y = p\y + ImageHeight(guy) ; the player is 160 pixels tall so his feet are 160 pixels lower than his head
	If p\y > GraphicsWidth()+100 Then lose_win = True 
End Function

;=======================================================================================================

Function UpdateMainLoop()
	loop_frame = loop_frame + 1
	loop_frame2 = loop_frame2 + 1 
End Function  

;=======================================================================================================

Function StartMusic()
	Delete Each music 	
	m.music = New music
	ResumeChannel bg_music
	PlayMusic(bg_music)
	m\vol = 1
	m\vv = 0
End Function

;========================================================================================================

Function UpdateMusic()
	If Not ChannelPlaying(bg_music) Then PlayMusic("Interim Nation Music\Interim Nation - Future Experience.mp3")
	If m\vol>0 Then m\vol = m\vol + m\vv Else m\vol = 0
	ChannelVolume bg_music,m\vol
End Function 

;===========================================================================================================